using System;

namespace Smdn.Applications.DirectoryAnalyzer
{
  public static class ConsoleEx
  {
    private static char[] progressChar = new char[] { '-', '\\', '|', '/' };
    private static int progressCharIndex = 0;

#if LINUX || (CONSOLE && WINDOWS)
    private static int cursorLeft;
    private static int cursorTop;
#endif

    public static void PreserveLoction()
    {
#if LINUX || (CONSOLE && WINDOWS)
      cursorLeft = Console.CursorLeft;
      cursorTop = Console.CursorTop;
#endif
    }

    public static void RevertLocation()
    {
#if LINUX || (CONSOLE && WINDOWS)
      Console.CursorLeft = cursorLeft;
      Console.CursorTop = cursorTop;
#endif
    }

    public static void WriteProgress()
    {
#if LINUX
      Console.Write(progressChar[progressCharIndex++]);
#elif WINDOWS
      Console.WriteLine(progressChar[progressCharIndex++]);
#endif

      if (progressChar.Length == progressCharIndex)
      {
        progressCharIndex = 0;
      }
    }

    public static void WriteProgress(int numerator, int denominator)
    {
      if (0 == denominator)
      {
        Console.Write("{0} ", denominator);
      }
      else
      {
        Console.Write("{0}/{1} ({2:P2}) ", numerator, denominator, (float)numerator / (float)denominator);
      }

      WriteProgress();
    }
  }
}
