using System;
using System.Collections.Generic;
using System.Text;

namespace Smdn.Applications.DirectoryAnalyzer.Graphing
{
  public class Grapher
  {
    private GraphingContext context = null;

    public Grapher(GraphingContext context)
    {
      if (null == context) throw new ArgumentNullException("context");

      this.context = context;
    }

    public void Create()
    {
      context.Status.StatusText = "グラフを作成中";

      switch (this.context.Parameter.Type)
      {
        case GraphType.Disc:
          context.Result.Graph = Disc.Disc.Create(context);
          break;

        default:
          throw new NotImplementedException(string.Format("{0}のグラフは作れません", context.Parameter.Type));
      }

      context.Status.StatusText = "グラフを作成が完了しました";
    }
}
}
