using System;
using System.Drawing;

namespace Smdn.Applications.DirectoryAnalyzer.Render
{
  using Graphing;

  public class PartialGraphImage : IDisposable
  {
    private IGraphElement[] elements = null;
    private Bitmap image = null;

    public IGraphElement[] Elements
    {
      get
      {
        return this.elements;
      }
    }

    public Bitmap Image
    {
      get
      {
        return this.image;
      }
    }

    public int ImageOffsetX = 0;
    public int ImageOffsetY = 0;

    public PartialGraphImage(IGraphElement[] elements, Bitmap partialImage)
    {
      if (null == elements) throw new ArgumentNullException("elements");

      this.elements = elements;
      this.image = partialImage;
    }

    public void Dispose()
    {
      if (null != image)
      {
        image.Dispose();
      }
    }

    void IDisposable.Dispose()
    {
      this.Dispose();
    }
  }
}
