using System;

namespace Smdn.Applications.DirectoryAnalyzer
{
  /// <summary>
  /// タスク実行コンテキストの基底クラス
  /// </summary>
  public abstract class TaskContext
  {
    /// <summary>
    /// タスクに引き渡すパラメータの基底クラス
    /// </summary>
    public abstract class TaskParameter
    {
    }

    /// <summary>
    /// タスクの状態の基底クラス
    /// </summary>
    public abstract class TaskStatus
    {
      public abstract uint Total { get;}
      public abstract uint Processed { get;}
      public string StatusText = string.Empty;
    }

    /// <summary>
    /// タスクの結果の基底クラス
    /// </summary>
    public abstract class TaskResult
    {
    }
  }

  /// <summary>
  /// タスク実行コンテキストの共通インターフェイス
  /// </summary>
  public interface ITaskContext
  {
    TaskContext.TaskParameter Parameter { get;}
    TaskContext.TaskResult Result { get;}
    TaskContext.TaskStatus Status { get;}
  }
}