using System;
using System.Drawing;
using System.Windows.Forms;

namespace Smdn.Applications.DirectoryAnalyzer.UI
{
  using Util;

  public partial class MainWindow
  {
    private void IntializeIcon()
    {
      Bitmap icon = null;

      // フォルダを選択して解析
      icon = Util.Icon.GetIcon(IconType.FolderSelection);

      toolStripMenuItemVisualize_Directory.Image = icon;
      toolStripButtonVisualizeDirectory.Image = icon;

      // SpecialFolder・デバイスを解析
      foreach (ToolStripItem item in toolStripMenuItemVisualize.DropDownItems)
      {
        if (item is DirectorySelectionToolStripMenuItem)
        {
          (item as DirectorySelectionToolStripMenuItem).Image = Util.Icon.GetIcon((item as IDirectorySelectionControl).Directory);
        }
        else if (item is DeviceSelectionToolStripMenuItem)
        {
          (item as DeviceSelectionToolStripMenuItem).Image = Util.Icon.GetIcon((item as IDeviceSelectionControl).Device);
        }
      }

      foreach (ToolStripItem item in toolStripMain.Items)
      {
        if (item is DirectorySelectionToolStripButton)
        {
          (item as DirectorySelectionToolStripButton).Image = Util.Icon.GetIcon((item as IDirectorySelectionControl).Directory);
        }
        else if (item is DeviceSelectionToolStripButton)
        {
          (item as DeviceSelectionToolStripButton).Image = Util.Icon.GetIcon((item as IDeviceSelectionControl).Device);
        }
      }
    }
  }
}
