using System;
using System.Drawing;

namespace Smdn.Applications.DirectoryAnalyzer.Util
{
  using FileSystem;

  public enum IconType
  {
    Folder,
    DesktopFolder,
    MyDocumentFolder,
    ProgramFilesFolder,
    FolderSelection,
  }

  public static partial class Icon
  {
    private static readonly Bitmap DefaultIcon = new Bitmap(16, 16);

    public static Bitmap GetIcon(IconType type)
    {
#if LINUX
      return GetIcon_Linux(type);
#elif WINDOWS
      return GetIcon_Windows(type);
#endif
    }

    public static Bitmap GetIcon(Directory directory)
    {
#if LINUX
      return GetIcon_Linux(directory);
#elif WINDOWS
      return GetIcon_Windows(directory);
#endif
    }

    public static Bitmap GetIcon(Device device)
    {
#if LINUX
      return GetIcon_Linux(device.Type);
#elif WINDOWS
      return GetIcon_Windows(device.Type);
#endif
    }
  }
}
