#if WINDOWS 

using System;
using System.Runtime.InteropServices;

namespace Smdn.Applications.DirectoryAnalyzer.Util.Windows
{
  [StructLayout(LayoutKind.Sequential, Pack = 4)]
  public struct POINT
  {
    public int x;
    public int y;

    public POINT(int x, int y)
    {
      this.x = x;
      this.y = y;
    }
  }

  [StructLayout(LayoutKind.Sequential, Pack = 4)]
  public struct SIZE
  {
    public int cx;
    public int cy;

    public SIZE(int cx, int cy)
    {
      this.cx = cx;
      this.cy = cy;
    }
  }

  public sealed partial class PlatformApi
  {
    private PlatformApi()
    {
    }

    [DllImport("kernel32.dll", SetLastError = true)]
    [return: MarshalAs(UnmanagedType.Bool)]
    public static extern bool CloseHandle(IntPtr hObject);

    [DllImport("gdi32.dll", SetLastError = true)]
    public static extern IntPtr CreateCompatibleDC(IntPtr hDC);

    [DllImport("user32.dll", SetLastError = true)]
    public static extern IntPtr GetDC(IntPtr hWnd);

    [DllImport("user32.dll", SetLastError = true)]
    public static extern int ReleaseDC(IntPtr hWnd, IntPtr hDC);

    [DllImport("gdi32.dll", SetLastError = true)]
    [return: MarshalAs(UnmanagedType.Bool)]
    public static extern bool DeleteDC(IntPtr hdc);

    [DllImport("gdi32.dll", SetLastError = true)]
    public static extern IntPtr SelectObject(IntPtr hdc, IntPtr hgdiobj);

    [DllImport("gdi32.dll", SetLastError = true)]
    [return: MarshalAs(UnmanagedType.Bool)]
    public static extern bool DeleteObject(IntPtr hObject);

    [DllImport("gdi32.dll", SetLastError = true)]
    public static extern int GetObject(IntPtr handle, int cbBuffer, IntPtr lpvObject);

    [DllImport("kernel32.dll", SetLastError = true, EntryPoint = "GlobalAddAtom", CharSet = CharSet.Auto)]
    public extern static ushort GlobalAddAtom(string lpString);

    [DllImport("kernel32.dll", SetLastError = true, EntryPoint = "GlobalDeleteAtom")]
    public extern static ushort GlobalDeleteAtom(ushort nAtom);

  }
}
#endif
